import es
import vecmath
import time

info = es.AddonInfo()
info.basename = 'deathmap'
info.version = '0.4s'
info.name = 'Deathmap srcds part'
info.url = 'http://addons.eventscripts.com/addons/view/deathmap/'
info.description = 'Tracks deaths on maps and accumulates these stats to be viewed visually'

mypath = es.getAddonPath(info.basename)
gamename = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').rpartition('/')[2]
openfile = None

def es_map_start(ev):
    global openfile, filename
    if openfile:
        openfile.close()
    filename = mypath + '/data/'+ev['mapname']
    openfile = open(filename, 'a')
    openfile.write('--version %s--%s--%s--\n'%(
        info.version, gamename, time.strftime('%Y-%m-%d')
        )
                   )

def load():
    mn = str(es.ServerVar('eventscripts_currentmap'))
    if mn:
        es_map_start({'mapname': mn})

    es.ServerVar('gj_deathmap_v', info.version, '%s version'%info.name).makepublic()

def unload():
    global openfile
    if openfile:
        openfile.close()
    openfile = None

def round_end(ev):
    if openfile:
        openfile.flush()

def player_death(ev):
    userid = int(ev['userid'])
    if userid:
        weapon = ev['weapon']
        usersteamid = ev['es_steamid']
        attacker = int(ev['attacker'])
        location = vecmath.vector(es.getplayerlocation(userid))
        userteam = int(ev['es_userteam'])
        if attacker:
            attackersteamid = ev['es_attackersteamid']
            attackerteam = int(ev['es_attackerteam'])
            attacklocation = vecmath.vector(es.getplayerlocation(attacker))
        else:
            attackersteamid = 'WORLD'
            attackerteam = 0
            attacklocation = vecmath.vector("0,0,0")
        try:
            headshot = int(ev['headshot'])
        except ValueError:
            headshot = 0
        openfile.write("%d %d %d %s %s %s %s %s\n"%(
            userteam, attackerteam, headshot,
            str(location), str(attacklocation),
            weapon, usersteamid, attackersteamid
            )
                       )
        
